package envoy.client.event;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Project: <strong>envoy-clientChess</strong><br>
 * File: <strong>EventBus.javaEvent.java</strong><br>
 * Created: <strong>04.12.2019</strong><br>
 * 
 * @author Kai S. K. Engelbart
 */
public class EventBus {

	private static EventBus eventBus;

	private List<EventHandler> handlers = new ArrayList<>();

	private EventBus() {}

	public EventBus getInstance() {
		if (eventBus == null) eventBus = new EventBus();
		return eventBus;
	}

	public void register(EventHandler... handlers) { this.handlers.addAll(Arrays.asList(handlers)); }

	public void dispatch(Event<?> event) { handlers.stream().filter(h -> h.supports().contains(event.getClass())).forEach(h -> h.handle(event)); }

	public List<EventHandler> getHandlers() { return handlers; }
}
